//#include "stdafx.h" //For Microsoft Visual Studio...comment out when compiling for other systems.
#include <iostream> // cin, myfile
#include <string>  //string ops
#include <algorithm> // Performs string shuffle
#include <fstream> //Writes the file to disk
#include <time.h>// Allows time as the random seed

using namespace std;

string sourceset = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";   //The programs starts with this string
string workset;  // The program copies sourceset into this string and then randomly shuffles it for each line in the sheet
string fileinput = ""; // This is the file name input from cin, that then has .txt appended to result in filename
string filename = "DRYAD"; // this is where the new sheet is saved... the default is DRYAD.txt
int pagetomake = 1; // Set the number of DRYAD sheets to generate
int currentpage = 0; // This is the couter that is incremented.   Pages are generated until this counter matches pagetomake


int main(void)

{
    srand(time(0)); // Seed the random generator with time (NOTE! Not Crypto Secure!)
    cout << "DRYAD Authentication Sheet Generater\n";  //credits printed to screen
    cout << "[c] 2017 Ronald Beal.   All Righs Reserved\n";
    cout << "http://www.citizenmilitem.com";   // my website
    cout << "\n \n \n";
    cout << "Hom many uniqe DRYAD sheets do you want (1-255)? ";
    cin >> pagetomake;
    if ((pagetomake <= 0) || (pagetomake > 255)) // input validation checking... if the user input is invalid, it defaults to 1 copy.
    {
        pagetomake = 1;

    }
    cout << "\n\nName of file to save DRYAD sheet? ";// no file extension necessary
    cin >> fileinput;
    filename = (fileinput + ".txt");// appends .txt to file name

    ofstream myfile;
    myfile.open(filename.c_str());  //This is the name of the file that all of the DRYAD sheets will be written to.
    char setletter = ('A'); //This has two purposes.  It will be the letter displayed at the begenning of each line, and it serves as the line counter.
    while (currentpage < pagetomake) // Here is where the current page is compared to the numer of pages to make.
    {
        myfile << "I.D.____________________\n";
        myfile << "     0   1   2   3  4  5   6  7   8  9 \n"; // This is the number match for the top of each sheet
        myfile << "   ABCD EFG HIJ KL MN OPQ RS TUV WX YZ \n"; // This is the letter match for the top of each sheet
        while ((setletter - 1) < ('Z')) // As long as the setletter is less than "Z" then the following is executed
        {
            workset = sourceset;  //   This is the sourceset alphabet being copied to workset
            random_shuffle(workset.begin(), workset.end()); // This is the workset being shuffled
            workset.insert(24, 1, ' '); // These are the inserts to put spaces in after it is shuffled
            workset.insert(22, 1, ' ');
            workset.insert(19, 1, ' ');
            workset.insert(17, 1, ' ');
            workset.insert(14, 1, ' ');
            workset.insert(12, 1, ' ');
            workset.insert(10, 1, ' ');
            workset.insert(7, 1, ' ');
            workset.insert(4, 1, ' ');

            myfile << setletter << "  " << workset << "\n"; // This writes the completed line to file
            setletter++;// this increments the setletter to the next letter in the alphabet
        }
        currentpage++; //This increments the page counter
        setletter = 'A'; //this resets the setletter to A for the next sheet
        myfile << "   ABCD EFG HIJ KL MN OPQ RS TUV WX YZ \n"; // This is printed at the bottom of each sheet
        myfile << "\n\n";// these line breaks put some spaces between sheets so it doesn't get too crowded
    }

    myfile.close(); //This closes file access
    cout << "\n\n" << pagetomake << " new DRYAD sheets written to: " << filename;
    cin >> filename;

    return (0); // End.

}

